unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, AppEvnts, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    StatusBar1: TStatusBar;
    Button6: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
    JM_STATUS, JM_COLOR, JM_CLOSE : Word;
  public
    { Public declarations }
    procedure WndProc(var TheMsg :TMessage); override;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  ShellAPI, JonsMessages;

procedure TForm1.Button1Click(Sender: TObject);

begin

ShellExecute(0, nil,
  PChar(ExtractFilePath(ParamStr(0)) + 'mainapp.exe'), nil, nil, SW_SHOWNORMAL);


end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SendNotifyMessage(HWND_BROADCAST, JM_CLOSE, 0, 0);
end;

procedure TForm1.WndProc(var TheMsg: TMessage);
var
  Handled :Boolean;
begin
  Handled := False;

  if TheMsg.Msg = JM_CLOSE then
    begin
//      ShowMessage('Close requested');
      Form1.Close;
      Handled := True;
    end;  //if JM_CLOSE
  if TheMsg.Msg = JM_COLOR then
    begin //set the problem 8o)
      if Form1.Color = TheMsg.WParam then
        Form1.Color := TheMsg.LParam
      else
        Form1.Color := TheMsg.WParam;
      Handled := True;
    end;  //if JM_COLOR
  if TheMsg.Msg = JM_STATUS then
    begin
      if Form1.Handle = HWND(TheMsg.WParam) then
        StatusBar1.SimpleText := 'We called the message'
      else
        StatusBar1.SimpleText := 'We were called by window ' + IntToStr(TheMsg.WParam) +
                ' but we''re window ' + IntToStr(Form1.Handle);

      Handled := True;
    end;
  if Handled <> True then
    inherited;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
JM_CLOSE := GetMessageIdent(JonsClose);
JM_COLOR := GetMessageIdent(JonsColor);
JM_STATUS := GetMessageIdent(JonsStatus);
end;


procedure TForm1.Button3Click(Sender: TObject);
begin
SendNotifyMessage(HWND_BROADCAST, JM_COLOR, clRed, 0);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
SendNotifyMessage(HWND_BROADCAST, JM_COLOR, clBtnFace, 0);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
SendNotifyMessage(HWND_BROADCAST, JM_COLOR, clRed, clBtnFace);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
SendNotifyMessage(HWND_BROADCAST, JM_STATUS, Form1.Handle, 0);
end;

end.
